#include <unistd.h>
#include <File.h>
#include <Message.h>
#include <Resources.h>
#include <stdio.h>
#include <string.h>
#include <termios.h>
#include "db.h"

void get_pwd(const char *prompt, char *result);

int main(int argc, const char **argv) {
	
	if (argc < 1) {
		usage:
		printf(	"chpwd usage -\n"
				"\tchpwd [user_name]\n"
				"\t\tchanges the password of the current user, or user_name if specified"
				
				"adduser -u 1543 -s /bin/zsh nathanw changeme\n");
		return 0;
	}
	InitDB();
	
	const char *user_to_change;
	if (argc == 1)
		user_to_change = NameForUid(getuid());
	else
		user_to_change = argv[2];
	if (user_to_change[0] == 0) {
		goto usage;
	}
	InitDB(false);
	if (status < 0) {
		printf("Help! Could not create user file.\n");
		return -3;
	}
	if (!HasEntry(user_to_change)) {
		printf("User %s does not exist.\n",user_to_change);
		return -4;
	}
	
	BMessage *user_data = DBEntry(user_to_change);
	
	char pass[255], new_pass[255];
	get_pwd("Old Password: ",pass);
	if (strcmp(user_data->FindString("password"),encrypt_pwd(pass)) != 0) {
		puts("Incorrect password.");
		return -1;
	}
	get_pwd("New Password: ",pass);
	get_pwd("Re-enter New Password: ",new_pass);
	
	if (strcmp(pass,new_pass) != 0) {
		puts("Passwords don't match.");
		return -1;
	}
	
	user_data->ReplaceString("password",encrypt_pwd(pass));
	
	//------Add to Resource------
	SetDBEntry(user_data,UINT_MAX,user_to_change);
	
	delete user_data;
	
	puts("Password changed succefully!");
	return 0;
}

void get_pwd(const char *prompt, char *result) {
	struct termios tio, saved_tio;
	printf(prompt);
	
	fcntl( fileno(stdin), F_SETFL, 0 );
	tcgetattr(fileno(stdin), &tio);
	saved_tio = tio;
	tio.c_lflag &= ~(ECHO | ECHOE | ECHOK | ECHONL);
	tcsetattr(fileno(stdin), TCSANOW, &tio);
	
	//----Get passwd------
	scanf("%s",result);
	
	//----Turn echo on
	tcsetattr(fileno(stdin), TCSANOW, &saved_tio);
	
	//fcntl( fileno(tty), F_SETFL, O_NONBLOCK );
 		
	
	result[254] = 0;
	puts("");
}