#include <File.h>
#include "db.h"

int status = 1;
BResources data; //---How sweet is this? Indexed by id and name. Perfect.

void InitDB(bool read_only,const char *path) {
	status = 0;
	BFile file(path,read_only ? B_READ_ONLY : (B_READ_WRITE | B_CREATE_FILE));
	if (file.InitCheck() != B_OK) {
		status = -1;
		return;
	}
	if (data.SetTo(&file) != B_OK) {
		if (read_only) {
			status = -2;
			return;
		} else {
			if (data.SetTo(&file,true) != B_OK) {
				status = -2;
				return;
			}
		}
	}
}
		
uid_t UidForName(const char *uname) {
	if (status == 1)
		InitDB();
	int32 id;
	size_t size;
	return (data.GetResourceInfo('MSGG',uname,&id,&size) ? uid_t(id) : UINT_MAX);
}

const char *NameForUid(uid_t uid) {
	if (status == 1)
		InitDB();
	const char *uname;
	size_t size;
	return (data.GetResourceInfo('MSGG',uid,&uname,&size) ? uname : NULL);
}

BMessage *DBEntry(const char *uname) {
	if (status == 1)
		InitDB();
	BMessage *to_return = new BMessage;
	size_t res_size;
	const void *res = data.LoadResource('MSGG',uname,&res_size);
	if ((res == NULL) || (res_size == 0) || (to_return->Unflatten((const char *)res) != B_OK))
		return NULL;
	return to_return;
}

BMessage *DBEntry(uid_t uid) {
	if (status == 1)
		InitDB();
	BMessage *to_return = new BMessage;
	size_t res_size;
	const void *res = data.LoadResource('MSGG',uid,&res_size);
	if ((res == NULL) || (res_size == 0) || (to_return->Unflatten((const char *)res) != B_OK))
		return NULL;
	return to_return;
}
		
bool HasEntry(const char *uname) {
	if (status == 1)
		InitDB();
	return data.HasResource('MSGG',uname);
}

bool HasEntry(uid_t uid) {
	if (status == 1)
		InitDB();
	return data.HasResource('MSGG',uid);
}

void SetDBEntry(BMessage *to_set, uid_t uid, const char *uname) {
	if (status == 1)
		InitDB();
	if (uname == NULL)
		uname = NameForUid(uid);
	if (uid == UINT_MAX) {
		if (HasEntry(uname)) {
			uid = UidForName(uname);
		} else {
			for (uid = 0; (uid <= UINT_MAX) && (data.HasResource('MSGG',uid)); uid++) {
				//-----Do nothing-----
			}
		}
	}
	data.RemoveResource('MSGG',uid);
	if (to_set != NULL) {
		BMallocIO flat;
		to_set->Flatten(&flat);
		data.AddResource('MSGG',uid,flat.Buffer(),flat.BufferLength(),uname);
	}
	data.Sync();
}